package 
{
	import flash.display.Sprite;
	import flash.display.Bitmap;
	import flash.events.Event;
	import flash.geom.Matrix;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	import flash.ui.Keyboard;

	/**
	 * boing SMASH: A game hastily created for Ludum Dare 23.  See README.txt
	 * Released under the CC BY-NC-SA 3.0 license.
	 * @author Tim Park
	 */
	[Frame(factoryClass = "Preloader")]
	public class Main extends Sprite 
	{
		private var plyrx:Array = [0, 0];
		private var plyrdir:Array = [0, 0];
		private var plyrframe:Array = [0, 0];
		private var plyrdead:Array = [0, 0];
		private var plyrfix:Array = [0, 0];
		private var plyrkick:Array = [0, 0];
		private var plyrhealth:Array = [0, 0];
		private var mode:int; // 0 title  1 game
		private var gameover:Boolean;
		private var roty:int = 0, rotz:int = 18, rotydir:int;
		private const BALLXMIN:int = 105; // - 26;
		private const BALLYMIN:int = 141;
		private const BALLXMAX:int = 536;
		private const BALLYMAX:int = 332;
		private const BALLYRATEMAX:int = 100; // 50 will bounce faster
		private const PLYRXMIN:int = BALLXMIN - 16;
		private const PLYRXMAX:int = BALLXMAX + 5;
		private const PLYRY:int = 440 - 27;
		private const PLYRSPEED:int = 3;
		private var ballx:int = BALLXMAX, bally:int = BALLYMAX;
		private var ballxdir:int, ballydir:int;
		private var ballxspeed:int = 5, ballyspeed:int = 5;
		private var pts:Array = [
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]]];
		private var pts2:Array = [
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]]];
		private var pts3:Array = [
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]],
[[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0],[0,0,0]]];
private var mc0:Sprite = new Sprite();
private var mc5:Sprite = new Sprite();
[Embed(source="../lib/boing.mp3")]	private var boing:Class;
[Embed(source="../lib/boom.mp3")]	private var boom:Class;
[Embed(source="../lib/done.mp3")]	private var done:Class;
[Embed(source="../lib/hammer.mp3")]	private var hammer:Class;
[Embed(source="../lib/kick.mp3")]	private var kick:Class;
[Embed(source="../lib/splat.mp3")]	private var splat:Class;
private var sound0:Array = [ // 6
new boing, new boom, new done, new hammer, new kick, new splat];
private var sound1:Array = [ // 6
new boing, new boom, new done, new hammer, new kick, new splat];
private const NUMBUILDINGS:int = 19;
private const NUMBUILDINGTYPES:int = 10;
[Embed(source="../lib/tower.png")]			private var tower:Class;
[Embed(source="../lib/hospital.png")]		private var hospital:Class;
[Embed(source="../lib/cafe.png")]			private var cafe:Class;
[Embed(source="../lib/food.png")]			private var food:Class;
[Embed(source="../lib/houseb.png")]			private var houseb:Class;
[Embed(source="../lib/houseg.png")]			private var houseg:Class;
[Embed(source="../lib/housep.png")]			private var housep:Class;
[Embed(source="../lib/skyscraper1.png")]	private var skyscraper1:Class;
[Embed(source="../lib/skyscraper2.png")]	private var skyscraper2:Class;
[Embed(source="../lib/skyscraper3.png")]	private var skyscraper3:Class;
[Embed(source="../lib/skyscraper4.png")]	private var skyscraper4:Class;
private var buildingimg:Array = [ // 11
new tower, new hospital, new cafe, new food, new houseb, new houseg, new skyscraper1, new skyscraper2, new skyscraper3, new skyscraper4, new housep];
private var buildingfixrate:Array = [
5, 15, 34, 25, 20, 20, 7, 9, 11, 13, 20];
private const MULT:int = 20;
private var buildingscore:Array = [
35*MULT, 25*MULT, 6*MULT, 15*MULT, 20*MULT, 20*MULT, 33*MULT, 31*MULT, 29*MULT, 20*MULT];
[Embed(source="../lib/ztower.png")]			private var ztower:Class;
[Embed(source="../lib/zhospital.png")]		private var zhospital:Class;
[Embed(source="../lib/zcafe.png")]			private var zcafe:Class;
[Embed(source="../lib/zfood.png")]			private var zfood:Class;
[Embed(source="../lib/zhouseb.png")]		private var zhouseb:Class;
[Embed(source="../lib/zhouseg.png")]		private var zhouseg:Class;
[Embed(source="../lib/zhousep.png")]		private var zhousep:Class;
[Embed(source="../lib/zskyscraper1.png")]	private var zskyscraper1:Class;
[Embed(source="../lib/zskyscraper2.png")]	private var zskyscraper2:Class;
[Embed(source="../lib/zskyscraper3.png")]	private var zskyscraper3:Class;
[Embed(source="../lib/zskyscraper4.png")]	private var zskyscraper4:Class;
private var buildingdimg:Array = [ // 11
new ztower, new zhospital, new zcafe, new zfood, new zhouseb, new zhouseg, new zskyscraper1, new zskyscraper2, new zskyscraper3, new zskyscraper4, new zhousep];
private var buildingindex:Array = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]; // 19
private var buildinghealth:Array = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]; // 19

[Embed(source="../lib/title.png")]	private var title:Class;
private var titleScreen:* = new title();

[Embed(source="../lib/yleft0.png")]	private var yleft0:Class;
[Embed(source="../lib/yleft1.png")]	private var yleft1:Class;
[Embed(source="../lib/yleft2.png")]	private var yleft2:Class;
[Embed(source="../lib/yup0.png")]	private var yup0:Class;
[Embed(source="../lib/yup1.png")]	private var yup1:Class;
[Embed(source="../lib/ykick.png")]	private var ykick:Class;
[Embed(source="../lib/ysplat.png")]	private var ysplat:Class;
private var yplyr:Array = [ // 7
new yleft0, new yleft1, new yleft0, new yleft2, new yup0, new yup1, new ykick, new ysplat];

[Embed(source="../lib/xleft0.png")]	private var xleft0:Class;
[Embed(source="../lib/xleft1.png")]	private var xleft1:Class;
[Embed(source="../lib/xleft2.png")]	private var xleft2:Class;
[Embed(source="../lib/xup0.png")]	private var xup0:Class;
[Embed(source="../lib/xup1.png")]	private var xup1:Class;
[Embed(source="../lib/xkick.png")]	private var xkick:Class;
[Embed(source="../lib/xsplat.png")]	private var xsplat:Class;
private var xplyr:Array = [ // 7
new xleft0, new xleft1, new xleft0, new xleft2, new xup0, new xup1, new xkick, new xsplat];
private var score:Array = [0, 0];
private var scoretext:Array = [new TextField(), new TextField(), new TextField(), new TextField()];
		private var key:KeyPoll;

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}

		private function drawBox(mc:Bitmap, x:int, y:int, flip:Boolean = false):void
		{
			var matrix:Matrix = new Matrix();
			matrix.identity();
			if (flip) matrix.scale( -1, 1);
			matrix.translate(x, y);
			mc5.graphics.beginBitmapFill(mc.bitmapData, matrix);
			mc5.graphics.drawRect(x, y, mc.width, mc.height);
			mc5.graphics.endFill();
		}
		
		private function initStuff():void
		{
			var i:int, j:int;
			gameover = false;
			for (i = 0; i < 2; i++)
			{
				score[i] = 0;
				plyrframe[i] = 0;
				plyrdead[i] = 0;
				plyrfix[i] = 0;
				plyrkick[i] = 0;
				plyrhealth[i] = 100;
			}
			plyrdir[0] = 1;
			plyrdir[1] = -1;
			plyrx[0] = PLYRXMIN;
			plyrx[1] = PLYRXMAX;
			scoretext[2].text = "";
			scoretext[3].text = "";
			ballx = BALLXMIN + Math.floor(Math.random() * (BALLXMAX - BALLXMIN));
			bally = BALLYRATEMAX / 2;
			ballxdir = (Math.floor(Math.random() * 100) < 50) ? 1 : -1;
			ballydir = 1;
			rotydir = (Math.floor(Math.random() * 100) < 50) ? 1 : -1;
			ballxspeed = ballyspeed = 4;
			for (i = 0; i < NUMBUILDINGS; i++)
			{
				buildingindex[i] = -1;
				buildinghealth[i] = 100;
			}
			// Place buildings on left side
			for (i = 2; i < NUMBUILDINGTYPES; i++)
			{
				do { j = Math.floor(Math.random() * 11); } while (buildingindex[j] != -1);
				buildingindex[j] = i;
			}
			// Place buildings on right side
			for (i = 2; i < NUMBUILDINGTYPES; i++)
			{
				do { j = Math.floor(Math.random() * 10); } while (buildingindex[j+11] != -1);
				buildingindex[j+11] = i;
			}
			// Place another skyscraper
			do { j = Math.floor(Math.random() * NUMBUILDINGS); } while (buildingindex[j] != -1);
			buildingindex[j] = 6;
			// Place hospital
			do { j = Math.floor(Math.random() * NUMBUILDINGS); } while (buildingindex[j] != -1);
			buildingindex[j] = 1;
			// Place tower
			for (i = 0; i < NUMBUILDINGS; i++)
				if (buildingindex[i] == -1)
					buildingindex[i] = 0;

			// Set up score/gameover texts
			var tmpFormat:TextFormat;
			tmpFormat = scoretext[0].getTextFormat();
			tmpFormat.align = TextFormatAlign.LEFT;
			tmpFormat.bold = true;
			tmpFormat.font = "_sans";
			tmpFormat.size = 18;
			scoretext[0].defaultTextFormat = tmpFormat;
			scoretext[0].x = 61;
			scoretext[0].y = 445;
			scoretext[0].width = 80;
			scoretext[0].textColor = 0xAA00AA;
			scoretext[0].text = "10";

			tmpFormat = scoretext[1].getTextFormat();
			tmpFormat.align = TextFormatAlign.RIGHT;
			tmpFormat.bold = true;
			tmpFormat.font = "_sans";
			tmpFormat.size = 18;
			scoretext[1].defaultTextFormat = tmpFormat;
			scoretext[1].x = 502;
			scoretext[1].y = 445;
			scoretext[1].width = 80;
			scoretext[1].textColor = 0xFFFF88;
			scoretext[1].text = "20";

			tmpFormat = scoretext[2].getTextFormat();
			tmpFormat.align = TextFormatAlign.CENTER;
			tmpFormat.bold = true;
			tmpFormat.font = "_sans";
			tmpFormat.size = 32;
			scoretext[2].defaultTextFormat = tmpFormat;
			scoretext[2].x = 0;
			scoretext[2].y = 207;
			scoretext[2].width = 640;
			scoretext[2].textColor = 0x66FF66;
			scoretext[2].text = "";

			tmpFormat = scoretext[3].getTextFormat();
			tmpFormat.align = TextFormatAlign.CENTER;
			tmpFormat.bold = true;
			tmpFormat.font = "_sans";
			tmpFormat.size = 16;
			scoretext[3].defaultTextFormat = tmpFormat;
			scoretext[3].x = 0;
			scoretext[3].y = 240;
			scoretext[3].width = 640;
			scoretext[3].textColor = 0x66FF66;
			scoretext[3].text = "";
		}
		
		private function init(e:Event = null):void 
		{
			var i:int, j:int, k:int;
			var x1:int, y1:int, x2:int, y2:int, x3:int, x4:int, size:int = 32;
			removeEventListener(Event.ADDED_TO_STAGE, init);
			mode = 0;
			// entry point
			addChild(mc0);
			addChild(mc5);
			addChild(scoretext[0]);
			addChild(scoretext[1]);
			addChild(scoretext[2]);
			addChild(scoretext[3]);
			drawBox(titleScreen, 0, 0);
			key = new KeyPoll(stage);
			initStuff();
			// Background
			mc0.graphics.lineStyle(0, 0xAAAAAA, 0);
			mc0.graphics.beginFill(0xAAAAAA);
			mc0.graphics.moveTo(0,0);
			mc0.graphics.lineTo(640,0);
			mc0.graphics.lineTo(640,480);
			mc0.graphics.lineTo(0,480);
			mc0.graphics.lineTo(0,0);
			mc0.graphics.endFill();
			// Draw grid
			for (i = 0; i < 15; i++)
				for (j = 0; j < 12; j++)
				{
					x1 = 80 + (i * size);
					y1 = 35 + (j * size);
					x2 = x1 + size;
					y2 = y1 + size;
					mc0.graphics.lineStyle(2, 0xAA00AA, 1);
					mc0.graphics.moveTo(x1, y1);
					mc0.graphics.lineTo(x2, y1);
					mc0.graphics.lineTo(x2, y2);
					mc0.graphics.lineTo(x1, y2);
					mc0.graphics.lineTo(x1, y1);
				}
			// Draw bottom floor grid
			var offset:Array = [ 0, 12, 24, 36 ];
			for (i = 0; i < 15; i++)
				for (j = 0; j < 3; j++)
				{
					x1 = 80 + (i * size) + ((i - 7) * offset[j] / 16);
					y1 = 35 + (32*12) + (j * 5);
					x2 = 80 + ((i+1) * size) + ((i - 6) * offset[j] / 16);
					y2 = y1 + 5;
					x3 = 80 + (i * size) + ((i - 7) * offset[j+1] / 16);
					x4 = 80 + ((i+1) * size) + ((i - 6) * offset[j+1] / 16);
					mc0.graphics.lineStyle(1.5, 0xAA00AA, 1);
					mc0.graphics.moveTo(x1, y1);
					mc0.graphics.lineTo(x2, y1);
					mc0.graphics.lineTo(x4, y2);
					mc0.graphics.lineTo(x3, y2);
					mc0.graphics.lineTo(x1, y1);
				}
			// Set up ball points
			var mult:Array = [0, 0.3827, 0.7071, 0.9239, 1.0, 0.9239, 0.7071, 0.3827, 0];
			var mult2:Array = [0, 0.3827, 0.7071, 0.9239, 1.0, 1.0761, 1.2929, 1.6173, 2.0];
			for (i = 0; i < 17; i++)
				for (j = 0; j < 9; j++)
				{
					pts[j][i][0] = 100 * Math.cos(22.5 * i * Math.PI / 180.0) * mult[j];
					pts[j][i][1] = 100 * Math.cos(22.5 * j * Math.PI / 180.0);
					pts[j][i][2] = 100 * Math.sin(22.5 * i * Math.PI / 180.0) * mult[j];
				}
			mc0.addEventListener(Event.ENTER_FRAME, EveryFrame, false, 0, true);
		}

		private function EveryFrame(event:Event):void {
			var i:int, j:int, k:int, realbally:int;
			if (mode == 0) // title screen
			{
				for (i = 0; i < 4; i++)
					scoretext[i].text = "";
				mc5.graphics.clear();
				drawBox(titleScreen, 0, 0);
				if (key.isDown(32))
				{
					initStuff();
					mode = 1;
				}
			}
			else if (mode == 1) // game screen
			{
			// Check if all buildings smashed (if so, game over)
			if (gameover == false)
			{
				gameover = true;
				for (i = 0; i < NUMBUILDINGS; i++)
					if (buildinghealth[i] == 100)
						gameover = false;
			}
			// Set gameover text and maybe go back to title screen
			if (gameover)
			{
				scoretext[2].text = "GAME OVER";
				scoretext[3].text = "- Esc to continue -";
				if (key.isDown(27))
					mode = 0;
			}

			// Show score
			scoretext[0].text = score[0];
			scoretext[1].text = score[1];

			// Rotate ball
			roty += rotydir;
			if (roty >= 360) roty = 0;
			if (roty < 0) roty = 359;
			ballx += ballxdir * ballxspeed;
			// If bounced off x, reverse direction and x rotation
			if ((ballx < BALLXMIN) || (ballx > BALLXMAX))
			{
				ballxdir = -ballxdir;
				ballx += 2 * ballxdir * ballxspeed;
				rotydir = -rotydir;
				sound0[0].play();
			}
			bally += ballydir;
			// If bounced off floor, check for buildings/people to smash
			if (bally > BALLYRATEMAX)
			{
				var played:Boolean = false;
				bally -= BALLYRATEMAX;
				for (i = 0; i < NUMBUILDINGS; i++)
					if ((buildinghealth[i] != 0) && (ballx >= -1 + 102 + (i * 23)) && (ballx <= 1 + 102 + 20 + (i * 23)))
					{
						// Smash building
						buildinghealth[i] = 0;
						sound0[1].play();
						played = true;
					}
				if ((plyrdead[0] == 0) && (ballx >= plyrx[0] - 7) && (ballx <= plyrx[0] + 8 + 7))
				{
					// Squish purple player
					plyrdead[0] = 1;
					plyrhealth[0] = 0;
					sound0[5].play();
				}
				if ((plyrdead[1] == 0) && (ballx >= plyrx[1] - 7) && (ballx <= plyrx[1] + 8 + 7))
				{
					// Squish yellow player
					plyrdead[1] = 1;
					plyrhealth[1] = 0;
					sound1[5].play();
				}
				if (!played) sound0[0].play();
			}
			realbally = BALLYMIN + ((1.0 - Math.sin((bally * 180 / BALLYRATEMAX) * Math.PI / 180.0)) * (BALLYMAX - BALLYMIN));

			mc5.graphics.clear();
			// Draw buildings and/or rubble
			for (i = 0; i < NUMBUILDINGS; i++)
			{
				if (buildinghealth[i] == 100)
					drawBox(buildingimg[buildingindex[i]], 102 + (i * 23), 359);
				else
				{
					// If drawing rubble, also draw health bar
					const LINEY:int = 438;
					drawBox(buildingdimg[buildingindex[i]], 102 + (i * 23), 359);
					mc5.graphics.lineStyle(4, 0xFF0000, 1, true, "none", "none");
					mc5.graphics.moveTo(102 + (i * 23), LINEY);
					mc5.graphics.lineTo(102 + (i * 23)+21, LINEY);
					mc5.graphics.lineStyle(4, 0x00FF00, 1, true, "none", "none");
					mc5.graphics.moveTo(102 + (i * 23), LINEY);
					mc5.graphics.lineTo(102 + (i * 23)+(21*buildinghealth[i]/100), LINEY);
					mc5.graphics.lineStyle(0, 0xFF0000, 0);
				}
			}

			// Fixing/kicking timeouts
			for (i = 0; i < 2; i++)
			{
				if (plyrfix[i] > 0)  plyrfix[i]--;
				if (plyrkick[i] > 0)  plyrkick[i]--;
				if (plyrfix[i] == 3) plyrframe[i] = 4;
			}
			if (plyrdead[0] == 1)
				plyrframe[0] = 7;
			if (plyrdead[1] == 1)
				plyrframe[1] = 7;
			if (gameover == false)
			{
				if ((plyrfix[0] == 0) && (plyrkick[0] == 0))
				{
					if (key.isDown(65)) // A (move left)
					{
						plyrdir[0] = -1;
						plyrx[0] -= PLYRSPEED;
						if (plyrx[0] < PLYRXMIN)
							plyrx[0] = PLYRXMIN;
						plyrframe[0] = (plyrframe[0] + 1) % 4;
					}
					else if (key.isDown(68)) // D (move right)
					{
						plyrdir[0] = 1;
						plyrx[0] += PLYRSPEED;
						if (plyrx[0] > PLYRXMAX)
							plyrx[0] = PLYRXMAX;
						plyrframe[0] = (plyrframe[0] + 1) % 4;
					}
					else if (key.isDown(87)) // W (fix building)
					{
						var bldg0:int = -1;
						plyrfix[0] = 10;
						plyrframe[0] = 5;
						for (i = 0; i < NUMBUILDINGS; i++)
						{
							if ((plyrx[0] >= -5 + 102 + (i * 23)) && (plyrx[0] < -5 + 102 + 23 + (i * 23)))
								bldg0 = i;
						}
						if ((bldg0 != -1) && (buildinghealth[bldg0] < 100))
						{
							sound0[3].play();
							plyrhealth[0] += 10;
							score[0] += 10;
							if (plyrhealth[0] > 100)
								plyrhealth[0] = 100;
							buildinghealth[bldg0] += buildingfixrate[buildingindex[bldg0]];
							if (buildinghealth[bldg0] >= 100)
							{
								score[0] += buildingscore[buildingindex[bldg0]];
								buildinghealth[bldg0] = 100;
								sound0[2].play();
							}
						}
					}
					else if (key.isDown(83)) // S (kick other player)
					{
						plyrkick[0] = 10;
						plyrframe[0] = 6;
						if (plyrx[0] < plyrx[1])
							plyrdir[0] = 1;
						else
							plyrdir[0] = -1;
						if (Math.abs(plyrx[0] - plyrx[1]) < 15)
						{
							sound0[4].play();
							score[0] += 10;
							plyrx[1] += 10 * plyrdir[0];
							if (plyrx[1] < PLYRXMIN) plyrx[1] = PLYRXMIN;
							if (plyrx[1] > PLYRXMAX) plyrx[1] = PLYRXMAX;
							plyrhealth[1] -= 10;
							if (plyrhealth[1] <= 0)
								plyrdead[1] = 1;
						}
					}
					else plyrframe[0] = 0;
				}
				
				if ((plyrfix[1] == 0) && (plyrkick[1] == 0))
				{
					if (key.isDown(Keyboard.LEFT)) // move left
					{
						plyrdir[1] = -1;
						plyrx[1] -= PLYRSPEED;
						if (plyrx[1] < PLYRXMIN)
							plyrx[1] = PLYRXMIN;
						plyrframe[1] = (plyrframe[1] + 1) % 4;
					}
					else if (key.isDown(Keyboard.RIGHT)) // move right
					{
						plyrdir[1] = 1;
						plyrx[1] += PLYRSPEED;
						if (plyrx[1] > PLYRXMAX)
							plyrx[1] = PLYRXMAX;
						plyrframe[1] = (plyrframe[1] + 1) % 4;
					}
					else if (key.isDown(Keyboard.UP)) // fix building
					{
						var bldg1:int = -1;
						plyrfix[1] = 10;
						plyrframe[1] = 5;
						for (i = 0; i < NUMBUILDINGS; i++)
						{
							if ((plyrx[1] >= -5 + 102 + (i * 23)) && (plyrx[1] < -5 + 102 + 23 + (i * 23)))
								bldg1 = i;
						}
						if ((bldg1 != -1) && (buildinghealth[bldg1] < 100))
						{
							sound1[3].play();
							plyrhealth[1] += 10;
							score[1] += 10;
							if (plyrhealth[1] > 100)
								plyrhealth[1] = 100;
							buildinghealth[bldg1] += buildingfixrate[buildingindex[bldg1]];
							if (buildinghealth[bldg1] >= 100)
							{
								score[1] += buildingscore[buildingindex[bldg1]];
								buildinghealth[bldg1] = 100;
								sound1[2].play();
							}
						}
					}
					else if (key.isDown(Keyboard.DOWN)) // kick other player
					{
						plyrkick[1] = 10;
						plyrframe[1] = 6;
						if (plyrx[1] < plyrx[0])
							plyrdir[1] = 1;
						else
							plyrdir[1] = -1;
						if (Math.abs(plyrx[0] - plyrx[1]) < 15)
						{
							sound1[4].play();
							score[1] += 10;
							plyrx[0] += 10 * plyrdir[1];
							if (plyrx[0] < PLYRXMIN) plyrx[0] = PLYRXMIN;
							if (plyrx[0] > PLYRXMAX) plyrx[0] = PLYRXMAX;
							plyrhealth[0] -= 10;
							if (plyrhealth[0] <= 0)
								plyrdead[0] = 1;
						}
					}
					else plyrframe[1] = 0;
				}
			}
			if ((plyrdead[0] == 1) || (plyrdead[1] == 1))
				gameover = true;

			// Draw players
			// Frame 6 (kick) is larger than others so needs a special offset
			var offset:int = 0;
			if ((plyrframe[0] == 6) && (plyrdir[0] == -1))		offset = -2;
			else if ((plyrframe[0] == 6) && (plyrdir[0] == 1))	offset = 1;
			else												offset = 0;
			drawBox(xplyr[plyrframe[0]], plyrx[0] + offset, PLYRY, (plyrdir[0] == 1));
			if ((plyrframe[1] == 6) && (plyrdir[1] == -1))		offset = -2;
			else if ((plyrframe[1] == 6) && (plyrdir[1] == 1))	offset = 1;
			else												offset = 0;
			drawBox(yplyr[plyrframe[1]], plyrx[1] + offset, PLYRY, (plyrdir[1] == 1));

			// Draw player health bars
			const PLINEY:int = 446;
			mc5.graphics.lineStyle(4, 0xFF0000, 1, true, "none", "none");
			mc5.graphics.moveTo(63, PLINEY);
			mc5.graphics.lineTo(63 + 100, PLINEY);
			mc5.graphics.lineStyle(4, 0x00FF00, 1, true, "none", "none");
			mc5.graphics.moveTo(63, PLINEY);
			mc5.graphics.lineTo(63 + (100*plyrhealth[0]/100), PLINEY);
			mc5.graphics.lineStyle(0, 0xFF0000, 0);
			
			mc5.graphics.lineStyle(4, 0xFF0000, 1, true, "none", "none");
			mc5.graphics.moveTo(479, PLINEY);
			mc5.graphics.lineTo(479 + 100, PLINEY);
			mc5.graphics.lineStyle(4, 0x00FF00, 1, true, "none", "none");
			mc5.graphics.moveTo(479 + 100 - (100*plyrhealth[1]/100), PLINEY);
			mc5.graphics.lineTo(479 + 100, PLINEY);
			mc5.graphics.lineStyle(0, 0xFF0000, 0);
			
			// Rotate in x
			for (i = 0; i < 17; i++)
				for (j = 0; j < 9; j++)
				{
					pts2[j][i][0] = (Math.cos(roty * Math.PI / 180.0) * pts[j][i][0]) + (Math.sin(roty * Math.PI / 180.0) * pts[j][i][2]);
					pts2[j][i][1] = pts[j][i][1];
					pts2[j][i][2] = -(Math.sin(roty * Math.PI / 180.0) * pts[j][i][0]) + (Math.cos(roty * Math.PI / 180.0) * pts[j][i][2]);
				}
			// Rotate in z
			for (i = 0; i < 17; i++)
				for (j = 0; j < 9; j++)
				{
					pts3[j][i][0] = (Math.cos(rotz * Math.PI / 180.0) * pts2[j][i][0]) - (Math.sin(rotz * Math.PI / 180.0) * pts2[j][i][1]) + ballx;
					pts3[j][i][1] = (Math.sin(rotz * Math.PI / 180.0) * pts2[j][i][0]) + (Math.cos(rotz * Math.PI / 180.0) * pts2[j][i][1]) + realbally;
					pts3[j][i][2] = pts2[j][i][2];
				}

			// Draw shadow
			for (i = 0; i < 16; i++)
				for (j = 0; j < 8; j++)
					if ((pts2[j][i][0] > pts2[j][i+1][0]) || (pts2[j+1][i][0] > pts2[j+1][i+1][0])) // && (pts2[j][i][2] > 0))
					{
						var off:int = 50;
						mc5.graphics.lineStyle(0, 0x000000, 0);
						mc5.graphics.beginFill(0x000000, 0.25);
						mc5.graphics.moveTo(pts3[j][i][0]+off, pts3[j][i][1]);
						mc5.graphics.lineTo(pts3[j][i+1][0]+off, pts3[j][i+1][1]);
						mc5.graphics.lineTo(pts3[j+1][i+1][0]+off, pts3[j+1][i+1][1]);
						mc5.graphics.lineTo(pts3[j+1][i][0]+off, pts3[j+1][i][1]);
						mc5.graphics.lineTo(pts3[j][i][0]+off, pts3[j][i][1]);
						mc5.graphics.endFill();
					}
			// Draw ball
			for (i = 0; i < 16; i++)
				for (j = 0; j < 8; j++)
					if ((pts2[j][i][0] > pts2[j][i+1][0]) || (pts2[j+1][i][0] > pts2[j+1][i+1][0])) // && (pts2[j][i][2] > 0))
					{
						mc5.graphics.lineStyle(0, 0xFF0000, 0);
						if ((((i % 2) == 0) && ((j % 2) == 1)) ||
							(((i % 2) == 1) && ((j % 2) == 0)))
							mc5.graphics.beginFill(0xFF0000);
						else
							mc5.graphics.beginFill(0xFFFFFF);
						mc5.graphics.moveTo(pts3[j][i][0], pts3[j][i][1]);
						mc5.graphics.lineTo(pts3[j][i+1][0], pts3[j][i+1][1]);
						mc5.graphics.lineTo(pts3[j+1][i+1][0], pts3[j+1][i+1][1]);
						mc5.graphics.lineTo(pts3[j+1][i][0], pts3[j+1][i][1]);
						mc5.graphics.lineTo(pts3[j][i][0], pts3[j][i][1]);
						mc5.graphics.endFill();
					}
			}
		}
	}
}
